/*
*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	Vandarth!  (Altures Primus)
    Active Players Announcement Routines
	
		eecc2X:
		This File Manages Active Player Relations and other
		communications needs to Active Players.
		
		eecc++
	
		TD:

*/


char NotifyTileChange(unsigned char x, unsigned char y) {
   struct Sight2 *Current;
   struct ActivePlayer *Player;
   char Cntr;

   Current = GetSightChunk(x,y);
   if (Current!=NULL) {
      if (Current->ChunkType==0) {
      	for(Cntr=0;Cntr<2;Cntr++) {
         	if (Current->Player[Cntr]!=0) {
					if (SearchAPlayer_Code(Current->Player[Cntr])) {
						Player = GetAPlayer(Current->Player[Cntr]);
						if (Player!=NULL) {
							AddPlayerThreadQueue(Player, x, y, 1, 0);
						};
					}
				};
			};
      } else
         if (Current->ChunkType==1) {
	      	for(Cntr=0;Cntr<4;Cntr++)
   	      	if (((struct Sight4 *) Current)->Player[Cntr]!=0)
						if (SearchAPlayer_Code(((struct Sight4 *) Current)->Player[Cntr])) {
							Player = GetAPlayer(((struct Sight4 *) Current)->Player[Cntr]);
							if (Player!=NULL)
								AddPlayerThreadQueue(Player, x, y, 1, 0);
						}
         } else
            if (Current->ChunkType==2) {
		      	for(Cntr=0;Cntr<8;Cntr++)
   		      	if (((struct Sight8 *) Current)->Player[Cntr]!=0)
							if (SearchAPlayer_Code(((struct Sight8 *) Current)->Player[Cntr])) {
								Player = GetAPlayer(((struct Sight8 *) Current)->Player[Cntr]);
								if (Player!=NULL)
									AddPlayerThreadQueue(Player, x, y, 1, 0);
							}
            } else
               if (Current->ChunkType==3) {
			      	for(Cntr=0;Cntr<16;Cntr++)
   			      	if (((struct Sight16 *) Current)->Player[Cntr]!=0)
								if (SearchAPlayer_Code(((struct Sight16 *) Current)->Player[Cntr])) {
									Player = GetAPlayer(((struct Sight16 *) Current)->Player[Cntr]);
									if (Player!=NULL)
										AddPlayerThreadQueue(Player, x, y, 1, 0);
								}
               } else {
			      	for(Cntr=0;Cntr<32;Cntr++)
   			      	if (((struct Sight32 *) Current)->Player[Cntr]!=0)
								if (SearchAPlayer_Code(((struct Sight32 *) Current)->Player[Cntr])) {
									Player = GetAPlayer(((struct Sight32 *) Current)->Player[Cntr]);
									if (Player!=NULL)
										AddPlayerThreadQueue(Player, x, y, 1, 0);
								}
               }
   };
	return(0);
};


struct ActivePlayer *APlayerSpaceGetBlank(void) {
	struct ActivePlayer *Return;
	unsigned char x=1;
		
	pthread_mutex_lock(&MutEx_GSD);		
	Return = GameData.ActivePlayers;
	while (x<GameData.NoActivePlayers && Return->Code!=0) {
		Return = Return++;
	   x++;
	};
	if (!(x<GameData.NoActivePlayers && Return->Code==0)) {
		GameData.NoActivePlayers++;
		GameData.ActivePlayers = realloc(GameData.ActivePlayers, sizeof(struct ActivePlayer)*GameData.NoActivePlayers);		
		Return = (GameData.ActivePlayers+(GameData.NoActivePlayers-1));
		Return->Code = 1;
	};
	pthread_mutex_unlock(&MutEx_GSD);		
	return(Return);	
};


struct InactivePlayer *IPlayerSpaceGetBlank(void) {
	struct InactivePlayer *Return;
	unsigned char x=1;
		
	pthread_mutex_lock(&MutEx_GSD);		
	Return = GameData.InactivePlayers;
	while (x<GameData.NoInactivePlayers && Return->Code!=0) {
		Return = (GameData.InactivePlayers+x);
	   x++;
	};
	if (!(x<GameData.NoInactivePlayers && Return->Code==0)) {
		GameData.NoInactivePlayers++;
//		sprintf(Temp,"[[[%d]]]",sizeof(struct InactivePlayer)*GameData.NoInactivePlayers);print(Temp);
		GameData.InactivePlayers = realloc(GameData.InactivePlayers, sizeof(struct InactivePlayer)*GameData.NoInactivePlayers);
		Return = (GameData.InactivePlayers+(GameData.NoInactivePlayers-1));
	};
	pthread_mutex_unlock(&MutEx_GSD);
	return(Return);	
};

void ActiveLogOff(unsigned short int Code) {
	struct ActivePlayer *APlayer;
	struct InactivePlayer *IPlayer;
	char x;
	char Temp[30];
	FILE *LogFile;
	
	APlayer = GetAPlayer(Code);
	
	if (APlayer!=NULL) {
		IPlayer = IPlayerSpaceGetBlank();
		pthread_mutex_lock(&MutEx_GSD);
		(IPlayer->Code) = (APlayer->Code);
		(APlayer->Code) = 0;
		strcpy(IPlayer->Name, APlayer->Name);
		strcpy(IPlayer->UserName, APlayer->UserName);
		strcpy(IPlayer->Password, APlayer->Password);
		IPlayer->Money = APlayer->Money;
		IPlayer->Upkeep = APlayer->Upkeep;
		IPlayer->Income = APlayer->Income;
		IPlayer->Base = APlayer->Base;
		IPlayer->Unit = APlayer->Unit;
		IPlayer->Settlement = APlayer->Settlement;
		IPlayer->Trap = APlayer->Trap;
		IPlayer->Barrier = APlayer->Barrier;
		IPlayer->BaseCounter = APlayer->BaseCounter;
		IPlayer->UnitCounter = APlayer->UnitCounter;
		IPlayer->SettlementCounter = APlayer->SettlementCounter;
		IPlayer->TrapCounter = APlayer->TrapCounter;
		IPlayer->BarrierCounter = APlayer->BarrierCounter;
		for(x=0;x<8;x++)
			IPlayer->MapDefinition[x] = APlayer->MapDefinition[x];
		IPlayer->VisibleMap = APlayer->VisibleMap;
		IPlayer->UnitQueueLength = APlayer->UnitQueueLength;
		IPlayer->UnitQueueTop = APlayer->UnitQueueTop;
		IPlayer->UnitQueue = APlayer->UnitQueue;
		sprintf(Temp, "PlayerLogs/Log_%s.dat", APlayer->UserName);
		LogFile = fopen(Temp, "w");
		fclose(LogFile);
		strcpy(IPlayer->FileName, Temp);
		pthread_mutex_unlock(&MutEx_GSD);
	};
/*	MSS_CHECK_POINTER_VALIDITY(IPlayer);
	MSS_CHECK_POINTER_VALIDITY(IPlayer->Base);
	MSS_CHECK_POINTER_VALIDITY(IPlayer->Trap);
	MSS_CHECK_POINTER_VALIDITY(IPlayer->Settlement);
	MSS_CHECK_POINTER_VALIDITY(IPlayer->Unit);
	MSS_CHECK_POINTER_VALIDITY(IPlayer->Barrier);
	MSS_CHECK_POINTER_VALIDITY(IPlayer->VisibleMap);
	MSS_CHECK_POINTER_VALIDITY(IPlayer->UnitQueue);
*/	return;
};
