/*
*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	Vandarth!  (Altures Primus)
    Map Query Utility Routines
		eecc++:
	
		eecc2X:
		This provides for the functions to automate the basic Game
		Server Data Structures Query.
	
		TD:
			-		

*/
void print(char *message);


struct UnitDataTable *GetUnitData(unsigned char Type) {
	char x;
	
	for(x=0;x<UNITTYPES;x++) if (GameData.UnitData[x].Type==Type) return(&GameData.UnitData[x]);
	return(NULL);
};


/*  Hash Tables   */

void HT_UnitID_Setup(unsigned char InitSize) {
	if (HT_UnitIDo==NULL && HT_UnitIDe==NULL) {
		HT_UnitIDo=calloc(InitSize,sizeof(unsigned short int));
		HT_UnitIDe=calloc(InitSize,sizeof(unsigned short int));
		HT_UnitIDoLen = HT_UnitIDeLen = InitSize;
	};
};

void HT_UnitID_Defrag(unsigned char Spare) {   // Unimplemented
	
};

char HT_UnitID_Resize(unsigned short int *Len, unsigned short int **HT, signed char Interval) {
	unsigned short int x;
	
	*HT = realloc(*HT,sizeof(unsigned short int)*((*Len)+Interval));
	*Len = (*Len)+Interval;
	if (*HT==NULL) {
		fprintf(stderr,"\n[Hash Table -UnitID]  Insufficient Memory!");
		GCF_Critical=1;
	};
	if (Interval>0) {
		x = (*Len)-Interval;
		while (x<(*Len)) {
			*((*HT)+x) = 0;
			x++;
		};
	};
	return(0);
};

unsigned short int HT_UnitID_Get(void) {
	unsigned short int Return;
	unsigned short int x=0;
	char Found=0;
	signed int Blank=-1;
	
	while (!Found) {
		Return = rand()&8191;
		if ( Return&1 ) { // Odd
			pthread_mutex_lock(&MutEx_UnitIDo);
print("<1>");
			while ( x<HT_UnitIDoLen && *(HT_UnitIDo+x)!=Return) {
				if (*(HT_UnitIDo+x)==0 && Blank==-1) Blank=x;
				x++;
			};
print("<a2>");
			if (x>=HT_UnitIDoLen) {
				if (Blank!=-1) {
					*(HT_UnitIDo+Blank)=Return;
				} else {
					Blank = HT_UnitID_Resize(&HT_UnitIDoLen, &HT_UnitIDo, 10);
					*(HT_UnitIDo+Blank)=Return;
				};					
				Found=1;
			};
print("<a3>");
			pthread_mutex_unlock(&MutEx_UnitIDo);			
		} else { // Even
			pthread_mutex_lock(&MutEx_UnitIDe);
print("<b1>");
			while ( x<HT_UnitIDeLen && *(HT_UnitIDe+x)!=Return) {
				if (*(HT_UnitIDe+x)==0 && Blank==-1) Blank=x;
				x++;
			};
print("<b2>");
			if (x>=HT_UnitIDeLen) {
				if (Blank!=-1) {
					*(HT_UnitIDe+Blank)=Return;
				} else {
					Blank = HT_UnitID_Resize(&HT_UnitIDeLen, &HT_UnitIDe, 10);
					*(HT_UnitIDe+Blank)=Return;
				};					
				Found=1;
			};
print("<b3>");
			pthread_mutex_unlock(&MutEx_UnitIDe);			
		};
	};
	return(Return);	
};

char HT_UnitID_Remove(unsigned short int Value) {
	unsigned short int x=0;
	char Found=0;
	
	if ( Value&1 ) { // Odd
		pthread_mutex_lock(&MutEx_UnitIDo);
		while ( x<HT_UnitIDoLen && *(HT_UnitIDo+x)!=Value) x++;
		if (*(HT_UnitIDo+x)==Value) {*(HT_UnitIDo+x)=0;Found=1;};
		pthread_mutex_unlock(&MutEx_UnitIDo);
	} else { // Even
		pthread_mutex_lock(&MutEx_UnitIDe);
		while ( x<HT_UnitIDeLen && *(HT_UnitIDe+x)!=Value) x++;
		if (*(HT_UnitIDe+x)==Value) {*(HT_UnitIDe+x)=0;Found=1;};
		pthread_mutex_unlock(&MutEx_UnitIDe);
	};
	if (Found) return(0); else return(1);
};
