/*
*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	Vandarth!  (Altures Primus)
    Map Query Utility Routines
		eecc++:
	
		eecc2X:
		This provides for the functions that query the Map Data
		itself.
	
		TD:
			-		

*/



/*void refreshallx(void) {
	refresh();
	wrefresh(InfoLine);
	wrefresh(Status);
	wrefresh(Mesg);
	wrefresh(CommandLine);
};

void printn(char *string) {
	wprintw(Mesg,"%s",string);
	refreshallx();
};
*/
void print(char *h);

struct Sight2 *GetSightChunk(unsigned char x, unsigned char y) {
	struct Sight2 *Return=NULL;
	char Display[10];
	
	if (GameWorld[x][y].InSight) {
		print("[1]");
	
		
		Return = GameWorld[x][y].Data;
		print("[2]");
		if (Return!=NULL) {
		print("[3]");
			if ( Return->ChunkType>=0 && Return->ChunkType<=4 ) {
			
			if (GameWorld[x][y].Data!=NULL) {
				sprintf(Display,"---|%d|---",((struct Sight2 *) GameWorld[x][y].Data)->ChunkType);
				print(Display);
			};
			if (GameWorld[x][y].Data!=Return) {
				print("ERROR!!!");
			};
			print("++++");
				return(Return);
			};
		};
		print("[4]");
      pthread_mutex_lock(&MutEx_GW);
		print("[5]");
      GameWorld[x][y].InSight = 0;
		print("[6]");
      pthread_mutex_unlock(&MutEx_GW);				
		return(NULL);
	} else return(NULL);
};



struct Unit1 *GetUnitChunk(unsigned char x, unsigned char y) {
	struct Unit1 *Return=NULL;
	
	if (GameWorld[x][y].HasUnits) {
		
		Return = GameWorld[x][y].Data;
		while ( Return!=NULL ) {
			if ( Return->ChunkType>=5 && Return->ChunkType<=7 ) {
				return(Return);
			}
			Return = Return->Next;
		};
      pthread_mutex_lock(&MutEx_GW);
      GameWorld[x][y].HasUnits = 0;
      pthread_mutex_unlock(&MutEx_GW);				
		return(NULL);
	} else return(NULL);
};


struct Unit1 **GetB4UnitChunk(unsigned char x, unsigned char y) {
	struct Unit1 *Return=NULL;
	struct Unit1 **Return1=NULL;
	struct Sight2 *Temp;
	
	if (GameWorld[x][y].HasUnits) {
		Return1 = (struct Unit1 **) &GameWorld[x][y].Data;
		Return = GetUnitChunk(x,y);
		if (Return==NULL) goto GB4_2;
		while ( *Return1!=Return ) Return1 = (struct Unit1 **) &((*Return1)->Next);
		
		return(Return1);
	} else {
GB4_2:		
		// Must return Sight Chunk or Data Pointer;
		if ((Temp=GetSightChunk(x,y))!=NULL) { // There is!
			return((struct Unit1 **) &(Temp->Next));
		} else {		// No Sight!
			return((struct Unit1 **) &(GameWorld[x][y].Data));
		};		
	};
};



unsigned char UnitCount(unsigned char x, unsigned char y) {
   unsigned char Return=0;
   void *UnitChunk;
   unsigned char UnitNo=0;
	
	if ((UnitChunk = GetUnitChunk(x,y))!=NULL) {
		UnitNo = ((struct Unit1 *) UnitChunk)->ChunkType;
		if (UnitNo==5) {
			return(1);			
		} else
			if (UnitNo==6) {
				for(UnitNo=0;UnitNo<4;UnitNo++)
					if (((struct Unit4 *) UnitChunk)->Units[UnitNo].Type != 0) Return++;
				return(Return);
			} else {
				for(UnitNo=0;UnitNo<8;UnitNo++)
					if (((struct Unit8 *) UnitChunk)->Units[UnitNo].Type != 0) Return++;
				return(Return);			
			};	
	} else return(Return);
};


struct Trap *GetTrapChunk(unsigned char x, unsigned char y) {
	struct Trap *Return=NULL;
	
	if (GameWorld[x][y].IsTrapped) {
		
		Return = GameWorld[x][y].Data;
		while ( Return!=NULL ) {
			if ( Return->ChunkType==8) {
				return(Return);
			}
			Return = Return->Next;
		};
      pthread_mutex_lock(&MutEx_GW);
      GameWorld[x][y].IsTrapped = 0;
      pthread_mutex_unlock(&MutEx_GW);				
		return(NULL);
	} else return(NULL);
};

struct Barrier *GetBarrierChunk(unsigned char x, unsigned char y) {
	struct Barrier *Return=NULL;
	
	if (GameWorld[x][y].HasBuilding) {
		Return = GameWorld[x][y].Data;
		while ( Return!=NULL ) {
			if ( Return->ChunkType==12) {
				return(Return);
			}
			Return = Return->Next;
		};
		return(NULL);
	} else return(NULL);
};

struct Base *GetBaseChunk(unsigned char x, unsigned char y) {
	struct Base *Return=NULL;
	
	if (GameWorld[x][y].HasBase) {
		
		Return = GameWorld[x][y].Data;
		while ( Return!=NULL ) {
			if ( Return->ChunkType==10) {
				return(Return);
			}
			Return = Return->Next;
		};
      pthread_mutex_lock(&MutEx_GW);
      GameWorld[x][y].HasBase = 0;
      pthread_mutex_unlock(&MutEx_GW);				
		return(NULL);
	} else return(NULL);
};


struct Base **GetB4BaseChunk(unsigned char x, unsigned char y) {
	struct Base *Return=NULL;
	struct Base *Return2=NULL;
	struct Base **Return1=NULL;
	
	struct Sight2 *Temp;
	
	if (GameWorld[x][y].HasBase) {
		Return1 = (struct Base **) &GameWorld[x][y].Data;
		Return = GetBaseChunk(x,y);
		if (Return==NULL) goto GB4_2;
		while ( *Return1!=Return ) Return1 = (struct Base **) &((*Return1)->Next);		
		return(Return1);
	} else {
GB4_2:		
		// Must return Sight Chunk or Data Pointer;
		Return = (struct Base *) GameWorld[x][y].Data;
		if (Return==NULL) return((struct Base **) &(GameWorld[x][y].Data));
		while (Return->ChunkType<10 && Return!=NULL) {
			Return2 = Return;
			Return = Return->Next;
		};
		return((struct Base **) &(Return2->Next));
	};
};



struct Settlement *GetSettlementChunk(unsigned char x, unsigned char y) {
	struct Settlement *Return=NULL;
	
	if (GameWorld[x][y].HasBuilding) {
		
		Return = GameWorld[x][y].Data;
		while ( Return!=NULL ) {
			if ( Return->ChunkType==9) {
				return(Return);
			}
			Return = Return->Next;
		};
      pthread_mutex_lock(&MutEx_GW);
      GameWorld[x][y].HasBuilding = 0;
      pthread_mutex_unlock(&MutEx_GW);				
		return(NULL);
	} else return(NULL);
};

struct Settlement **GetB4SettlementChunk(unsigned char x, unsigned char y) {
	struct Settlement *Return=NULL;
	struct Settlement *Return2=NULL;
	struct Settlement **Return1=NULL;
	
	struct Sight2 *Temp;
	
	if (GameWorld[x][y].HasBuilding) {
		Return1 = (struct Settlement **) &GameWorld[x][y].Data;
		Return = GetSettlementChunk(x,y);
		if (Return==NULL) goto GB4_2;
		while ( *Return1!=Return ) Return1 = (struct Settlement **) &((*Return1)->Next);		
		return(Return1);
	} else {
GB4_2:		
		Return = (struct Settlement *) GameWorld[x][y].Data;
		if (Return==NULL) return((struct Settlement **) &(GameWorld[x][y].Data));
		while (Return->ChunkType<9 && Return!=NULL) {
			Return2 = Return;
			Return = Return->Next;
			if (Return==NULL) goto ExitNOW;
		};
ExitNOW:
		return((struct Settlement **) &(Return2->Next));
	};
};

unsigned short int GetTileOwner(unsigned char x, unsigned char y) {
	void *Current;

	if (GameWorld[x][y].Data!=NULL) {
		Current = GameWorld[x][y].Data;
GTO_Check:
		if (((struct Sight2 *) Current)->ChunkType>=0 && ((struct Sight2 *) Current)->ChunkType<=4) {
			// Sight Data Chunk
			if (((struct Sight2 *) Current)->Next==NULL) return(0);
			Current = ((struct Sight2 *) Current)->Next;
			goto GTO_Check;
		} else
			if (((struct Sight2 *) Current)->ChunkType>=5 && ((struct Sight2 *) Current)->ChunkType<=7) {
				return(((struct Unit1 *) Current)->Player);
			} else
				if (((struct Sight2 *) Current)->ChunkType==8) {
					return(((struct Trap *) Current)->Player);
				} else
					if (((struct Sight2 *) Current)->ChunkType==9) {
						return(((struct Settlement *) Current)->Player);
					} else
						if (((struct Sight2 *) Current)->ChunkType==10) {
							return(((struct Base *) Current)->Player);
						} else
							if (((struct Sight2 *) Current)->ChunkType==11) {
								return(((struct Barrier *) Current)->Player);
							} else
								if (((struct Sight2 *) Current)->ChunkType==12) {
									return(((struct Radar *) Current)->Player);
								} else return(0);
	} else return(0);
};





/*  Sight Chunk Related    */

char AddFoggedSightDef(unsigned char x, unsigned char y, struct ActivePlayer *Player) {
	struct FoggedSight *VisibleMap;
	char x1,y1,m,z;
	char Cntr;
	unsigned char Loc;
	
	x1 = x / 32;
	y1 = y / 32;
	if (BitGet(Player->MapDefinition[y1],x1)) {
		Loc = (x1<<4) | y1;
		
		Cntr=0;
		VisibleMap = Player->VisibleMap;
		while ((VisibleMap+Cntr)->Location!=Loc) Cntr++;
		x1 = x % 32;
		y1 = y % 32;
		
		if (!XBitGet((VisibleMap+Cntr)->Data[y1],x1)) {
			(VisibleMap+Cntr)->Data[y1]=XBitStore((VisibleMap+Cntr)->Data[y1], 1, x1);
		};
	} else {
		pthread_mutex_lock(&MutEx_GSD);
		Player->MapDefinition[y1]=BitStore(Player->MapDefinition[y1], 1, x1);

		Cntr=0;
		for(z=0;z<8;z++)
			for(m=0;m<8;m++) if (BitGet(Player->MapDefinition[z], m)) Cntr++;
				
		VisibleMap = Player->VisibleMap = realloc(Player->VisibleMap, sizeof(struct FoggedSight)*Cntr);
		Loc = (x1<<4) | y1;
		x1 = x % 32;
		y1 = y % 32;
		
		Cntr--;
		(VisibleMap+Cntr)->Location = Loc;
		for(z=0;z<32;z++) (VisibleMap+Cntr)->Data[z]=0;
		
		(VisibleMap+Cntr)->Data[y1]=XBitStore((VisibleMap+Cntr)->Data[y1], 1, x1);
		
		pthread_mutex_unlock(&MutEx_GSD);
	};
	return(0);
	
};


char AddSight(unsigned char x, unsigned char y, struct ActivePlayer *Player) {
   struct Sight2 *New;
   unsigned short int *Blank=NULL;
   char Cntr;
   unsigned int Owner = Player->Code;

AD_Again:
	if (GameWorld[x][y].InSight) {  // With Sight Chunk
		New = GameWorld[x][y].Data;
		if (New->ChunkType==0) {
			for(Cntr=0;(Cntr<2 && Blank==NULL);Cntr++) {
				if (New->Player[Cntr]==Owner) goto AD_Found;
				if (New->Player[Cntr]==0) Blank = &(New->Player[Cntr]);
			};
			if (Blank==NULL) { // No Space   (Up 2 - 4)
				pthread_mutex_lock(&MutEx_GW);
				(struct Sight4 *) New = GameWorld[x][y].Data = realloc(New, sizeof(struct Sight4));
				((struct Sight4 *) New)->ChunkType=1;
				((struct Sight4 *) New)->Player[2]=Owner;
				((struct Sight4 *) New)->Player[3]=0;
				pthread_mutex_unlock(&MutEx_GW);
			} else {
				pthread_mutex_lock(&MutEx_GW);
				*Blank = Owner;
				pthread_mutex_unlock(&MutEx_GW);
			};		
		} else if (New->ChunkType==1) {
				for(Cntr=0;(Cntr<4 && Blank==NULL);Cntr++) {
					if (((struct Sight4 *) New)->Player[Cntr]==Owner) goto AD_Found;
					if (((struct Sight4 *) New)->Player[Cntr]==0) Blank = &(((struct Sight4 *) New)->Player[Cntr]);
				};
				if (Blank==NULL) { // No Space   (Up 4 - 8)
					pthread_mutex_lock(&MutEx_GW);
					(struct Sight8 *) New = GameWorld[x][y].Data = realloc(New, sizeof(struct Sight8));
					((struct Sight8 *) New)->ChunkType=2;
					((struct Sight8 *) New)->Player[4]=Owner;
					((struct Sight8 *) New)->Player[5]=0;
					((struct Sight8 *) New)->Player[6]=0;
					((struct Sight8 *) New)->Player[7]=0;
					pthread_mutex_unlock(&MutEx_GW);
				} else {
					pthread_mutex_lock(&MutEx_GW);
					*Blank = Owner;
					pthread_mutex_unlock(&MutEx_GW);
				};
			} else if (New->ChunkType==2) {
					for(Cntr=0;(Cntr<8 && Blank==NULL);Cntr++) {
						if (((struct Sight8 *) New)->Player[Cntr]==Owner) goto AD_Found;
						if (((struct Sight8 *) New)->Player[Cntr]==0) Blank = &(((struct Sight8 *) New)->Player[Cntr]);
					};
					if (Blank==NULL) { // No Space   (Up 8 - 16)
						pthread_mutex_lock(&MutEx_GW);
						(struct Sight16 *) New = GameWorld[x][y].Data = realloc(New, sizeof(struct Sight16));
						((struct Sight16 *) New)->ChunkType=3;
						((struct Sight16 *) New)->Player[8]=Owner;
						for(Cntr=9;Cntr<16;Cntr++) ((struct Sight16 *) New)->Player[Cntr]=0;
						pthread_mutex_unlock(&MutEx_GW);
					} else {
						pthread_mutex_lock(&MutEx_GW);
						*Blank = Owner;
						pthread_mutex_unlock(&MutEx_GW);
					};
				} else if (New->ChunkType==3) {
						for(Cntr=0;(Cntr<16 && Blank==NULL);Cntr++) {
							if (((struct Sight16 *) New)->Player[Cntr]==Owner) goto AD_Found;
							if (((struct Sight16 *) New)->Player[Cntr]==0) Blank = &(((struct Sight16 *) New)->Player[Cntr]);
						};
						if (Blank==NULL) { // No Space   (Up 16 - 32)
							pthread_mutex_lock(&MutEx_GW);
							(struct Sight32 *) New = GameWorld[x][y].Data = realloc(New, sizeof(struct Sight32));
							((struct Sight32 *) New)->ChunkType=4;
							((struct Sight32 *) New)->Player[16]=Owner;
							for(Cntr=17;Cntr<32;Cntr++) ((struct Sight32 *) New)->Player[Cntr]=0;
							pthread_mutex_unlock(&MutEx_GW);
						} else {
							pthread_mutex_lock(&MutEx_GW);
							*Blank = Owner;
							pthread_mutex_unlock(&MutEx_GW);
						};
					} else if (New->ChunkType==4) {
							for(Cntr=0;(Cntr<32 && Blank==NULL);Cntr++) {
								if (((struct Sight32 *) New)->Player[Cntr]==Owner) goto AD_Found;
								if (((struct Sight32 *) New)->Player[Cntr]==0) Blank = &(((struct Sight32 *) New)->Player[Cntr]);
							};
							if (Blank==NULL) { // No Space
								fprintf(stderr,"\n[AddSight] Sight Chunk (%d,%d) full.  Pity %d!",x,y,Owner);
							} else {
								pthread_mutex_lock(&MutEx_GW);
								*Blank = Owner;
								pthread_mutex_unlock(&MutEx_GW);
							};
						} else {    // No Sight Chunk
							pthread_mutex_lock(&MutEx_GW);
							GameWorld[x][y].InSight = 0;
							pthread_mutex_unlock(&MutEx_GW);							
							goto AD_Again;
						};	
	} else {   // W/o Sight Chunk
		New = malloc(sizeof(struct Sight2));
		pthread_mutex_lock(&MutEx_GW);
		New->Next = GameWorld[x][y].Data;
		New->ChunkType=0;
		GameWorld[x][y].Data = New;
		GameWorld[x][y].InSight = 1;
		New->Player[0] = Owner;
		New->Player[1] = 0;		
		pthread_mutex_unlock(&MutEx_GW);
	};
AD_Found:	
	AddFoggedSightDef(x,y,Player);
	GetSightChunk(x,y);
	return(0);
};


