/*
*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	Vandarth!  (Altures Primus)
    Connection Manager Thread
	
		eecc2X:
		This thread accepts the port number from the Connection Manager
		and does the communication establishment with the client.  This
		does the basic security communications and the ID.  This also
		creates the new threads for creation of new players with the
		game world or the continuation of an old player.
		
		eecc++
	
		TD:

*/

char NewPlayerBase(unsigned char *x, unsigned char *y, unsigned char *sx, unsigned char *sy) {
	unsigned char x1, y1;
	short int rx, ry;
	int Cntr, Cntr1;
	
	for(Cntr=0;Cntr<MAXBASELOOKUP;Cntr++) {
		x1 = rand()%256;
		y1 = rand()%256;
		
		// Check terrain
		if (GameWorld[x1][y1].Terrain == TSEA || GameWorld[x1][y1].Terrain == TMOUNTAIN) goto next;
		// Check for buildings
		if (GameWorld[x1][y1].HasBuilding || GameWorld[x1][y1].IsTrapped) goto next;
		// Check for Barrier
		if (GameWorld[x1][y1].InBarrier) goto next;
		// Check base range
		for(rx=-MINBASEDISTANCE;rx<=MINBASEDISTANCE;rx++)
			for(ry=-MINBASEDISTANCE;ry<=MINBASEDISTANCE;ry++) {
				if ( sqrt(pow((double) ry,2) + pow((double) rx,2)) < ((double) MINBASEDISTANCE) ) {
					if (GameWorld[rx+x1][ry+y1].HasBase) goto next;		
				};
			}
		for(Cntr1=0;Cntr1<MAXNEWSETTLEMENTLOOKUP;Cntr1++) {
			rx = (rand()%(short int) ((MAXSETTLEMENTDISTANCE+1)*2)) -(MAXSETTLEMENTDISTANCE+1);
			ry = (rand()%(short int) ((MAXSETTLEMENTDISTANCE+1)*2)) -(MAXSETTLEMENTDISTANCE+1);
			if (rx==0 && ry==0) goto retry;
			if ( sqrt(pow((double) ry,2) + pow((double) rx,2)) > ((double) MAXSETTLEMENTDISTANCE) ) goto retry;
			if ( GameWorld[rx+x1][ry+y1].Terrain == TSEA || GameWorld[rx+x1][ry+y1].Terrain == TMOUNTAIN ) goto retry;
			goto done;
retry:
		};
done:		
		*sx = rx+x1;
		*sy = ry+y1;
		*x = x1;
		*y = y1;
		return(0);
next:
	};
};



char CreatePlayer(char *UserName, char *Password, char *CompleteName, int port) {
	struct ActivePlayer *Active;
	unsigned char x, y, Sx, Sy;
	unsigned short int Codex;
	char *Temp = malloc(100);
	unsigned char cntr;
	char ErrCode;
	
	// Search for Duplicates
	if (SearchAPlayer(UserName) != -1) {
		PortWriteLine(port,"1N\n");
		free(Temp);
		return(1);
	};
	if (SearchIPlayer(UserName) != -1) {
		PortWriteLine(port,"1N\n");
		free(Temp);
		return(1);
	};

	PortWriteLine(port,"1Y\n");
	
	
	
	// Look for good Base Location!	
	if (NewPlayerBase(&x, &y,&Sx,&Sy)) {
		PortWriteLine(port,"2N\n");
		return(2);
	};
	
	PortWriteLine(port,"2Y\n");

	Codex = FreePlayerCode();
	
	sprintf(Temp,"%d",Codex);

	PortWriteLine(port,"3Y\n");
	PortWriteLine(port,Temp);
	PortWriteLine(port,"\n");
	
	// Realloc Additional		->  Modification.... Use a function!
print("6");
	Active = APlayerSpaceGetBlank();
	
	// Aquire GSD Lock
	pthread_mutex_lock(&MutEx_GSD);

		
	Active->Code = Codex;
	// Create the Data
print("6");
	strcpy(Active->Name, CompleteName);
	strcpy(Active->UserName, UserName);
	strcpy(Active->Password, Password);
print("6");
	Active->Money = GW_NEWMONEY;
	Active->Upkeep = 0;
	Active->Income = 0;
		Active->VisibleMap=NULL;
		for(cntr=0;cntr<8;cntr++) Active->MapDefinition[cntr]=0;
		Active->Base = NULL;
		Active->Settlement = NULL;
		Active->Unit = NULL;
		Active->Trap = NULL;
		Active->Barrier = NULL;
		Active->BaseCounter = 0;
		Active->SettlementCounter = 0;
		Active->UnitCounter = 0;
print("{d}");
		Active->TrapCounter = 0;
		Active->BarrierCounter = 0;
		
		Active->ThreadQueueLength = 0;
		Active->ThreadQueue = NULL;
		Active->UnitQueue=NULL;
		Active->UnitQueueLength=0;
		Active->UnitQueueTop=0;
	
	pthread_mutex_unlock(&MutEx_GSD);
		// Base     chk counters

print("{B}");
		if ((ErrCode=CreateBase(x,y,Codex,GW_NEWBASELEVEL,GW_NEWBASEINITPROD,"Base Name"))) {sprintf(Temp,"       -[NewConn|%d|%d]  Unable to create Base!",ErrCode,port);print(Temp);Err();N();};
print("{S}");
	
		// Settlement
		if ((ErrCode=CreateSettlement(Sx,Sy,Codex,GW_NEWSETTLEMENTLEVEL,"Settlement"))) {sprintf(Temp,"       -[NewConn|%d|%d]  Unable to create Settlement!",ErrCode,port);print(Temp);Err();N();};
MSS_LOG_INTERNAL_INFO;		
		// Unit
print("{1}");
		if (GW_NEWBASEUNIT1) if ((ErrCode=CreateUnit(x,y,Codex,GW_NEWBASEUNIT1,1))) {sprintf(Temp,"       -[NewConn|%d|%d]  Unable to create Base Unit (1)!",ErrCode,port);print(Temp);Err();N();};
print("{2}");
		if (GW_NEWBASEUNIT2) if ((ErrCode=CreateUnit(x,y,Codex,GW_NEWBASEUNIT2,1))) {sprintf(Temp,"       -[NewConn|%d|%d]  Unable to create Base Unit (2)!",ErrCode,port);print(Temp);Err();N();};
		
print("6");
		
		if (GW_NEWSETTLEMENTUNIT1) if ((ErrCode=CreateUnit(Sx,Sy,Codex,GW_NEWSETTLEMENTUNIT1,1))) {sprintf(Temp,"       -[NewConn|%d|%d]  Unable to create Settlement Unit (1)!",ErrCode,port);print(Temp);Err();N();};
print("a");
		if (GW_NEWSETTLEMENTUNIT2) if ((ErrCode=CreateUnit(Sx,Sy,Codex,GW_NEWSETTLEMENTUNIT2,1))) {sprintf(Temp,"       -[NewConn|%d|%d]  Unable to create Settlement Unit (2)!",ErrCode,port);print(Temp);Err();N();};

				
	// Return to Inactive Status
print("b");
	ActiveLogOff(Codex);
print("6");
//	MSS_REGISTER_CONSTANT_BLOCK(Active);
//	MSS_CHECK_POINTER_VALIDITY(Active->Base);
//	MSS_CHECK_POINTER_VALIDITY(Active);
//		MSS_DUMP_BLOCK(Active, "logs1");

	// Free GSD Lock
	PortWriteLine(port,"4Y\n");
	
	free(Temp);
	return(0);
};







void *ThreadNewConnection(void *data) {    // detachable
	int port;
	fd_set Read;
	char *Tokens[10];
	FILE *F;
	
	int x=0,Cntr=0;
	char *Temp = malloc(100);
	char Result;
	struct OldPlayerThreadInitData *Data;
	pthread_t T_OldPlayer;
	
	struct InactivePlayer *Player;
	
	
	port = *((int *) data);
	FD_ZERO(&Read);
	FD_SET(port, &Read);
	
	select(FD_SETSIZE,&Read,NULL,NULL,NULL);
	Temp = PortReadLine(port,Temp,100);
	sleep(2);
	if ((*Temp)=='N') {			// New Player
		// Parse Input
		x = Tokenize("\t", Tokens, Temp);
		// Now Create Player
		PortWriteLine(port,"0Y\n");
		Result =CreatePlayer(Tokens[1],Tokens[2],Tokens[3],port);
		switch (Result) {
			case 1:
//				PortWriteLine(port,"N[Err002: Existing Identity!]\n");
				if (NewConn_NotifyIdentity) printx("       -[NewConn]  Existing! |");printx(Tokens[1]);printx("|");printx(Tokens[2]);printx("|");printx(Tokens[3]);print("|");N();
				for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
				close(port);
				free(Temp);
				return;
			case 2:
//				PortWriteLine(port,"N[Err003: Map too crowded or Search too shallow!]\n");
				for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
				close(port);
				free(Temp);
				return;
			default:		
		}
//print("4");
		if ( Result ==1) {
		};
		if (NewConn_NotifyIdentity) printx("       -[NewConn]  |");printx(Tokens[1]);printx("|");printx(Tokens[2]);printx("|");printx(Tokens[3]);print("|");N();
		for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);

		// Disconnect! Successful!
		close(port);
	} else
		if ((*Temp)=='O') {		// Old Player
			x = Tokenize("\t", Tokens, Temp+1);
			if (x!=2) {
				PortWriteLine(port,"N01Identification Packet Incomplete or Corrupted!\n");
				for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
				close(port);
				free(Temp);
				return;
			}
			// Check if already active
			if (SearchAPlayer(Tokens[0])!=-1) {
				PortWriteLine(port,"N02Player already Playing!\n");
				for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
				close(port);
				free(Temp);
				return;
			};
			// Check if existing
			if ((Result = SearchIPlayer(Tokens[0]))==-1) {
				PortWriteLine(port,"N03Player does not exist!\n");
				for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
				close(port);
				free(Temp);
				return;
			};
			Player = ((GameData.InactivePlayers)+Result);
			// Check if correct Password
			if (strcmp(Player->Password,Tokens[1])) {
				PortWriteLine(port,"N04Wrong Password!\n");
				for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
				close(port);
				free(Temp);
				return;
			}
			sprintf(Temp,"Y%s\n", Player->Name);
			PortWriteLine(port,Temp);
			Data = malloc(sizeof(struct OldPlayerThreadInitData));
			Data->Port = port;
			Data->Player = Player;
			// Send to Old Player Thread for management
			if (pthread_attr_setstacksize(&attr, (PTHREAD_STACK_MIN+0x500))) {endwin();printf("01x1");exit(1);};
			if (pthread_create(&T_OldPlayer,&attr,ThreadOldPlayerConnection,(void *) Data)) {endwin();printf("01e");exit(1);};
			for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
			free(Temp);
			
			return;
		} else
			if (*(Temp)=='I') {
				sprintf(Temp,"Vandarth!%s\t%s\n","00.21.0101","Feb 13, 2001");
				PortWriteLine(port,Temp);
				sleep(1);
				close(port);
				free(Temp);
				return;
			} else
				if (*(Temp)=='V') {
					x = Tokenize("\t", Tokens, Temp+1);
//					fdopen(
					if (x!=2) {
						PortWriteLine(port,"N01Identification Packet Incomplete or Corrupted!\n");
						for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
						close(port);
						free(Temp);
						return;
					}
					// Check if already active
					if (SearchAPlayer(Tokens[0])!=-1) {
						PortWriteLine(port,"N02Player already Playing!\n");
						for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
						close(port);
						free(Temp);
						return;
					};
					// Check if existing
					if ((Result = SearchIPlayer(Tokens[0]))==-1) {
						PortWriteLine(port,"N03Player does not exist!\n");
						for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
						close(port);
						free(Temp);
						return;
					};
					Player = (GameData.InactivePlayers+Result);
					// Check if correct Password
					if (strcmp(Player->Password,Tokens[1])) {
						PortWriteLine(port,"N04Wrong Password!\n");
						for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
						close(port);
						free(Temp);
						return;
					}
					sprintf(Temp,"Y%s\n", Player->Name);
					PortWriteLine(port,Temp);
					for (Cntr=0;Cntr<x;Cntr++) free(Tokens[Cntr]);
					close(port);
					free(Temp);
					return;				
				} else {						// Illegal Input
					PortWriteLine(port,"N[CI01: Illegal Player Status Input!]\n");
					// Stop Dead!
					if (NewConn_NotifyOnDisconnect) {sprintf(Temp,"       -[NewConn:%d]  Illegal Input! Conn Closed!\n",port);print(Temp);};
					close(port);
					free(Temp);
					return;
				}
	// Call Connection Thread
	free(Temp);
	return;
};