/*
*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	Vandarth!  (Altures Primus)
    Connection Manager Thread
	
		eecc2X:
		This thread waits for incomming connections on port 4621 and
		does the basic ID feature.  Initialization of the connection
		is done.  And it passes the socket to another thread called
		New Connection Thread.
		
		eecc++
		NewConnectionThread -> This thread communicates with the client and set it up.
		
	
		TD:
			

*/
#define MAXHOSTNAME	10
#include "TNewConnectionThread.c"

void *ThreadConnectionManager(void *data) {    // detachable
	struct sockaddr_in sa, NewConn;
	char   myname[MAXHOSTNAME+1];
	struct hostent *hp;
	int    s,NewS,TempS, x;
	pthread_attr_t attr;
	pthread_t T_NewCon;
	char *Temp = malloc(sizeof(char)*100);


	//  Initialization Parameters
	print("       -[ConnMngr]  Started...\n");
	if (pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED)) {endwin();printf("CM01x");exit(1);};
	if (pthread_attr_setstacksize(&attr, (PTHREAD_STACK_MIN+0x50000))) {endwin();printf("CM01x1");exit(1);};
		
	memset(&sa, 0, sizeof(struct sockaddr_in)); 	/* clear our address */
	gethostname(myname, MAXHOSTNAME);           	/* who are we? */
	printx("       -[ConnMngr]  Hostname: ");print(myname);N();
	hp= gethostbyname(myname);                  	/* get our address info */
	if (hp == NULL) {                             	/* we don't exist !? */
		printx("       -[ConnMngr]  HostName Database Derivation Error!");Err();
		fprintf(stderr,"[ConnMngr]  HostName Database Derivation Error!\n");
		GCF_Critical=1;
		GCF_Threads++;
		return;
   };
    	
	//  Prepare Connection
	sa.sin_family= hp->h_addrtype;             	/* this is our host address */
	sa.sin_port= htons(4621);                		/* this is our port number */
	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) { 		/* create socket */
		printx("       -[ConnMngr]  Cannot Create Socket!");Err();N();
		fprintf(stderr,"[ConnMngr]  Cannot Create Socket!\n");
		GCF_Critical=1;
		GCF_Threads++;
		return;
	};
	if (bind(s,(struct sockaddr *)&sa,sizeof(struct sockaddr_in)) < 0) {
		printx("       -[ConnMngr]  Cannot BIND to Socket!");Err();N();
		fprintf(stderr,"[ConnMngr]  Cannot BIND to Socket!\n");
		GCF_Critical=1;
		close(s);
		GCF_Threads++;
		return;                           		/* bind address to socket */
	}
	printx("       -[ConnMngr]  Socket Bound.  Connection Preparing...");Ok();N();

	
	listen(s, 10);                             	/* max # of queued connects */
	NewS=1;
	GCF_Threads++;
	printx("       -[ConnMngr]  Socket Listening.  Ready to Accept Connections...");Ok();N();
	GSD_ConnectPort = s;
	while (!GCF_Terminate) {
	//  Listen to Connection
		if ((NewS = accept(s,(struct sockaddr *) &NewConn,(void *)sizeof(struct sockaddr_in))) < 0) {
			printx("       -[ConnMngr] Cannot Accept Connections! CRITICAL!");Err();N();
			fprintf(stderr,"[ConnMngr] Cannot Accept Connections! CRITICAL!\n");
			GCF_Close=1;
			return;
		}
	//  Spawn New Connection Thread
	   if (!GCF_Terminate) {
   		if (ConnMngr_NotifyOnConnect) {sprintf(Temp,"       -[ConnMngr]  One Conn Req Received (%d)!\n",NewS);print(Temp);};
	   	x = NewS;
		   if (pthread_create(&T_NewCon,&attr,ThreadNewConnection,(void*) &x)) {endwin();printf("CM01e");exit(1);};
	   };
	}
	close(NewS);
	close(s);
	printx("       -[ConnMngr] Server Connection Closed.");Ok();N();
	ThreadCountDecrement();
	free(Temp);
	return;
};