/*
*-+*-+*-+*-+*-+*-+*-+*-+*-+*-+
	Vandarth!  (Altures Primus)
    Old Player Connection Thread
	
		eecc2X:
		This Thread maintains a connection from a player.  It also
		handles the initialization part of an old player connection.
		
		eecc++
	
		TD:

*/


char MapFoggedVisible(unsigned char x, unsigned char y, struct ActivePlayer *Player) {
	struct FoggedSight *VisibleMap;
	char x1,y1;
	char Cntr;
	unsigned char Loc;
	
	x1 = x / 32;
	y1 = y / 32;
	if (BitGet(Player->MapDefinition[y1],x1)) {
		Loc = (x1<<4) | y1;
		
		Cntr=0;
		VisibleMap = Player->VisibleMap;
		while ((VisibleMap+Cntr)->Location!=Loc) Cntr++;
		x1 = x % 32;
		y1 = y % 32;
		
		return(XBitGet((VisibleMap+Cntr)->Data[y1],x1));
	};
	return(0);

};

char MapSightVisible(unsigned char x, unsigned char y, unsigned short int Code) {
	struct Sight2 *Sight;

	Sight = GetSightChunk(x,y);
	if (Sight!=NULL) {
		if (Sight->ChunkType==0) {
			for(x=0;x<2;x++)
				if (Sight->Player[x]==Code) return(1);
			return(0);
		} else
			if (Sight->ChunkType==1) {
				for(x=0;x<4;x++)
					if (((struct Sight4 *) Sight)->Player[x]==Code) return(1);
				return(0);
			} else
				if (Sight->ChunkType==2) {
				for(x=0;x<8;x++)
					if (((struct Sight8 *) Sight)->Player[x]==Code) return(1);
				return(0);
				} else
					if (Sight->ChunkType==3) {
						for(x=0;x<16;x++)
							if (((struct Sight16 *) Sight)->Player[x]==Code) return(1);
						return(0);
					} else {
						for(x=0;x<32;x++)
							if (((struct Sight32 *) Sight)->Player[x]==Code) return(1);
						return(0);
					};
	};
	return(0);
};

void SendPlayerTerrainData(char **Buffer, int *Length, unsigned char x, unsigned char y, struct ActivePlayer *Player) {
	unsigned char Cntr;
	unsigned char Cntr1;
	unsigned short int PlayerCode;
	char *Temp = malloc(80);

	// Terrain
	for(Cntr=0;Cntr<SETUP_CLIENT_HEIGHT;Cntr++) {
		for(Cntr1=0;Cntr1<SETUP_CLIENT_WIDTH;Cntr1++) {
			PortWriteChar(Buffer,Length,GameWorld[Cntr1+x][Cntr+y].Terrain);
		};
	};
	PortWriteString(Buffer, Length, "\n");
};

void SendPlayerSightData(char **Buffer, int *Length, unsigned char x, unsigned char y, struct ActivePlayer *Player) {
	unsigned char Cntr;
	unsigned char Cntr1;
	unsigned char Message;
	unsigned short int PlayerCode;

	// Terrain Visible
	for(Cntr=0;Cntr<SETUP_CLIENT_HEIGHT;Cntr++) {
		Message=0;
		for(Cntr1=0;Cntr1<SETUP_CLIENT_WIDTH;Cntr1++) {
			Message = BitStore(Message, MapFoggedVisible((x+Cntr1),(y+Cntr), Player), Cntr1);
		};
		PortWriteChar(Buffer, Length, Message);
	};
	PortWriteString(Buffer, Length, "\n");
	
	// Completely Visible
	PlayerCode = Player->Code;
	for(Cntr=0;Cntr<SETUP_CLIENT_HEIGHT;Cntr++) {
		Message=0;
		for(Cntr1=0;Cntr1<SETUP_CLIENT_WIDTH;Cntr1++) {
			Message = BitStore(Message, MapSightVisible((x+Cntr1),(y+Cntr), PlayerCode), Cntr1);
		};
		PortWriteChar(Buffer, Length, Message);		
	};
	PortWriteString(Buffer, Length, "\n");
	
};

void SendUnitData(char **Buffer, int *Length, unsigned char x, unsigned char y, struct ActivePlayer *Player) {
	char z;
	struct Unit1 *Unit;
	
	if ((Unit = GetUnitChunk( x, y ))!=NULL) {
		unsigned char Moves;
		float MovesPerTurn;
		float MovesLeft;
		char Turns;
		if (Unit->ChunkType==5) {
			if (Unit->Units[0].UnitID!=0) {
				if ((Unit->Player)==(Player->Code)) PortWriteString(Buffer, Length, "\t");
				else {
					char *Name;
					if ((Name=GetPlayerUserName(Unit->Player))==NULL) {
						PortWriteString(Buffer, Length, "Unknown\t");
					} else {
						PortWriteString(Buffer, Length, Name);
						free(Name);
						PortWriteString(Buffer, Length, "\t");						
					};
				};
				PortWriteSInt(Buffer, Length, Unit->Units[0].UnitID);
				PortWriteChar(Buffer, Length, Unit->Units[0].GroupID);
				PortWriteChar(Buffer, Length, Unit->Units[0].Type);
				PortWriteSInt(Buffer, Length, Unit->Units[0].Life);
				if (( ((long) GW_CurrentTurn) - ((long)(Unit->Units[0].Turns)) )<0) {
					MovesPerTurn = ( ((float)( (GetUnitData(Unit->Units[0].Type)) ->Movement)) /10);
					Turns = (float) ((long) GW_CurrentTurn+65000) - ((long)(Unit->Units[0].Turns));
					MovesLeft = (((float) ((int) (Unit->Units[0].Moves)))/10);
					Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
				} else {
					MovesPerTurn = ( ((float)( (GetUnitData(Unit->Units[0].Type)) ->Movement)) /10);
					Turns = (float) ((long) GW_CurrentTurn) - ((long)(Unit->Units[0].Turns));
					MovesLeft = (((float) ((int) (Unit->Units[0].Moves)))/10);
					Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
				};
				PortWriteSInt(Buffer, Length, Moves);
			};
		} else
			if (Unit->ChunkType==6) {
				if ((((struct Unit4 *) Unit)->Player)==(Player->Code)) PortWriteString(Buffer, Length, "\t");
				else {
					char *Name;
					if ((Name=GetPlayerUserName(((struct Unit4 *) Unit)->Player))==NULL) {
						PortWriteString(Buffer, Length, "Unknown\t");
					} else {
						PortWriteString(Buffer, Length, Name);
						free(Name);
						PortWriteString(Buffer, Length, "\t");						
					};
				};
				for(z=0;z<4;z++)
					if (((struct Unit4 *) Unit)->Units[z].UnitID!=0) {
						PortWriteSInt(Buffer, Length, ((struct Unit4 *) Unit)->Units[z].UnitID);
						PortWriteChar(Buffer, Length, ((struct Unit4 *) Unit)->Units[z].GroupID);
						PortWriteChar(Buffer, Length, ((struct Unit4 *) Unit)->Units[z].Type);
						PortWriteSInt(Buffer, Length, ((struct Unit4 *) Unit)->Units[z].Life);
						if (( ((long) GW_CurrentTurn) - ((long)(((struct Unit4 *) Unit)->Units[z].Turns)) )<0) {
							MovesPerTurn = ( ((float)( (GetUnitData(((struct Unit4 *) Unit)->Units[z].Type)) ->Movement)) /10);
							Turns = (float) ((long) GW_CurrentTurn+65000) - ((long)(((struct Unit4 *) Unit)->Units[z].Turns));
							MovesLeft = (((float) ((int) (((struct Unit4 *) Unit)->Units[z].Moves)))/10);
							Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
						} else {
							MovesPerTurn = ( ((float)( (GetUnitData(((struct Unit4 *) Unit)->Units[z].Type)) ->Movement)) /10);
							Turns = (float) (char) ((long) GW_CurrentTurn) - ((long)(((struct Unit4 *) Unit)->Units[z].Turns));
							MovesLeft = (((float) ((int) (((struct Unit4 *) Unit)->Units[z].Moves)))/10);
							Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
						};
						PortWriteSInt(Buffer, Length, Moves);
					};
			} else {
				if ((((struct Unit8 *) Unit)->Player)==(Player->Code)) PortWriteString(Buffer, Length, "\t");
				else {
					char *Name;
					if ((Name=GetPlayerUserName(((struct Unit8 *) Unit)->Player))==NULL) {
						PortWriteString(Buffer, Length, "Unknown\t");
					} else {
						PortWriteString(Buffer, Length, Name);
						free(Name);
						PortWriteString(Buffer, Length, "\t");						
					};
				};
				for(z=0;z<8;z++)
					if (((struct Unit8 *) Unit)->Units[z].UnitID!=0) {
						PortWriteSInt(Buffer, Length, ((struct Unit8 *) Unit)->Units[z].UnitID);
						PortWriteChar(Buffer, Length, ((struct Unit8 *) Unit)->Units[z].GroupID);
						PortWriteChar(Buffer, Length, ((struct Unit8 *) Unit)->Units[z].Type);
						PortWriteSInt(Buffer, Length, ((struct Unit8 *) Unit)->Units[z].Life);
						if (( ((long) GW_CurrentTurn) - ((long)(((struct Unit8 *) Unit)->Units[z].Turns)) )<0) {
							MovesPerTurn = ( ((float)( (GetUnitData(((struct Unit8 *) Unit)->Units[z].Type)) ->Movement)) /10);
							Turns = (float) ((long) GW_CurrentTurn+65000) - ((long)(((struct Unit8 *) Unit)->Units[z].Turns));
							MovesLeft = (((float) ((int) (((struct Unit8 *) Unit)->Units[z].Moves)))/10);
							Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
						} else {
							MovesPerTurn = ( ((float)( (GetUnitData(((struct Unit8 *) Unit)->Units[z].Type)) ->Movement)) /10);
							Turns = (float) ((long) GW_CurrentTurn) - ((long)(((struct Unit8 *) Unit)->Units[z].Turns));
							MovesLeft = (((float) ((int) (((struct Unit8 *) Unit)->Units[z].Moves)))/10);
							Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
						};
						PortWriteSInt(Buffer, Length, Moves);
					};					
			};
	};
	PortWriteString(Buffer, Length, "\n");
};

void SendCompleteData(char **Buffer, int *Length, FILE *Socket, unsigned char x, unsigned char y, struct ActivePlayer *Player) {
	unsigned char Cntr;
	unsigned char Cntr1;
	
	SendPlayerTerrainData(Buffer, Length, x, y, Player);
	PortWriteBufferFlush(*Buffer, Socket);
	PortWriteBufferClear(*Buffer);
	
	SendPlayerSightData(Buffer, Length, x, y, Player);
	PortWriteBufferFlush(*Buffer, Socket);
	PortWriteBufferClear(*Buffer);
	
	// Units Sending
	for(Cntr=0;Cntr<SETUP_CLIENT_HEIGHT;Cntr++) {
		for(Cntr1=0;Cntr1<SETUP_CLIENT_WIDTH;Cntr1++) {
			SendUnitData(Buffer, Length, (x+Cntr1), (y+Cntr), Player);
			PortWriteBufferFlush(*Buffer, Socket);
			PortWriteBufferClear(*Buffer);
		};
	};
	
};

void *ThreadOldPlayerConnection(void *Data) {
	struct InactivePlayer *IPlayer;
	struct ActivePlayer *Player;
	short int PlayerCode;
	int Port;
	FILE *Socket, *LogFile;
	int BufferLength;
	char *Buffer;
	char FileName[40];
	
	unsigned Cntr;
	
	char *Temp;
	
	unsigned char x,y;
	unsigned int z;
	struct FoggedSight *FogSight;
	struct Bases *BaseList;
	struct Base *Base;
	int *Hash;
	int HashCounter;
	struct Listing *UnitList;
	struct Unit1 *Unit;
	struct Trap *Trap;
	struct Barrier *Barrier;
	struct Settlement *Settlement;
	
	Temp = malloc(sizeof(char)*200);
	Port = ((struct OldPlayerThreadInitData *) Data)->Port;
	IPlayer = ((struct OldPlayerThreadInitData *) Data)->Player;
	free(Data);
	
	// Open the File Streams
	Socket = fdopen(Port, "w+");
	
	// Make the Shift to Active
	Player = APlayerSpaceGetBlank();
	pthread_mutex_lock(&MutEx_GSD);
	(Player->Code) = (IPlayer->Code);
	strcpy(Player->Name, IPlayer->Name);
	strcpy(Player->UserName, IPlayer->UserName);
	strcpy(Player->Password, IPlayer->Password);
	Player->Money = IPlayer->Money;
	Player->Upkeep = IPlayer->Upkeep;
	Player->Income = IPlayer->Income;
	Player->Base = IPlayer->Base;
	Player->Unit = IPlayer->Unit;
	Player->Settlement = IPlayer->Settlement;
	Player->Trap = IPlayer->Trap;
	Player->Barrier = IPlayer->Barrier;
	Player->BaseCounter = IPlayer->BaseCounter;
	Player->UnitCounter = IPlayer->UnitCounter;
	Player->SettlementCounter = IPlayer->SettlementCounter;
	Player->TrapCounter = IPlayer->TrapCounter;
	Player->BarrierCounter = IPlayer->BarrierCounter;
	strcpy(FileName, IPlayer->FileName);
	for(x=0;x<8;x++)
		Player->MapDefinition[x] = IPlayer->MapDefinition[x];
	Player->VisibleMap = IPlayer->VisibleMap;
	Player->UnitQueueLength = IPlayer->UnitQueueLength;
	Player->UnitQueueTop = IPlayer->UnitQueueTop;
	Player->UnitQueue = IPlayer->UnitQueue;
	// Create the Thread Queue
	Player->ThreadQueue = malloc(sizeof(struct ThreadQueue)*PLAYER_THREAD_QUEUE_INIT_LENGTH);
	Player->ThreadQueueLength = PLAYER_THREAD_QUEUE_INIT_LENGTH;
	Player->ThreadQueueTop = 0;
	(IPlayer->Code) = 0;
	pthread_mutex_unlock(&MutEx_GSD);
	PlayerCode = Player->Code;
	
	BufferLength = 50;
	Buffer = malloc(sizeof(char)*BufferLength);
	PortWriteBufferClear(Buffer);
	
	// Send the Server Defaults
		// Unit Type, Names.
		for(z=0;z<UNITTYPES;z++) {
			PortWriteChar(&Buffer,&BufferLength, GameData.UnitData[z].Type);
			PortWriteString(&Buffer,&BufferLength, GameData.UnitData[z].Name);
			PortWriteString(&Buffer,&BufferLength, "\t");
			PortWriteSInt(&Buffer,&BufferLength, GameData.UnitData[z].CostMoney);
			PortWriteSInt(&Buffer,&BufferLength, GameData.UnitData[z].CostProduction);
			PortWriteSInt(&Buffer,&BufferLength, GameData.UnitData[z].UpkeepCost);
		};
		PortWriteString(&Buffer, &BufferLength, "\n");
		PortWriteBufferFlush(Buffer, Socket);
		PortWriteBufferClear(Buffer);
		// Settlement Names
		for(z=0;z<SETTLEMENTTYPES;z++) {
			PortWriteString(&Buffer,&BufferLength, GameData.SettlementData[z].Name);
			PortWriteString(&Buffer,&BufferLength, "\t");
		};
		PortWriteString(&Buffer, &BufferLength, "\n");
		PortWriteBufferFlush(Buffer, Socket);
		PortWriteBufferClear(Buffer);
		
		// Trap Names
		for(z=0;z<TRAPTYPES;z++) {
			PortWriteString(&Buffer,&BufferLength, GameData.TrapData[z].Name);
			PortWriteString(&Buffer,&BufferLength, "\t");
			PortWriteChar(&Buffer,&BufferLength, GameData.TrapData[z].ConstMoney);
			PortWriteChar(&Buffer,&BufferLength, GameData.TrapData[z].ConstHours);
		};
		PortWriteString(&Buffer, &BufferLength, "\n");		
		PortWriteBufferFlush(Buffer, Socket);
		PortWriteBufferClear(Buffer);
		
		// Terrain Names
		for(z=0;z<TERRAINTYPES;z++) {
			PortWriteString(&Buffer,&BufferLength, GameData.TerrainData[z].Name);
			PortWriteString(&Buffer,&BufferLength, "\t");
		};
		PortWriteString(&Buffer, &BufferLength, "\n");
		
	// Send the Required Data!
		// Money,Upkeep,Income
		PortWriteInt(&Buffer, &BufferLength, Player->Money);
		PortWriteInt(&Buffer, &BufferLength, Player->Upkeep);
		PortWriteInt(&Buffer, &BufferLength, Player->Income);
		PortWriteString(&Buffer, &BufferLength, "\n");
			
/*		// Total Map Sight Definition
			// Count the number of Definitions
			for(z=0,y=0;z<8;z++)
				for(x=0;x<8;x++) if (BitGet(Player->MapDefinition[z], x)) y++;
			// Scan the Sight Chunk
			FogSight = Player->VisibleMap;
			for(x=0;x<y;x++) {
				PortWriteChar(&Buffer, &BufferLength,(FogSight+x)->Location);
				for(z=0;z<32;z++) PortWriteInt(&Buffer, &BufferLength, (FogSight+x)->Data[z]);
			};
		PortWriteString(&Buffer, &BufferLength, "\n");
		PortWriteBufferFlush(Buffer, Socket);
		PortWriteBufferClear(Buffer);
*/		
		// Bases  --listing only w/names
		BaseList = Player->Base;
		for(z=0;z<(Player->BaseCounter);z++) {
			x=((BaseList+z)->X);
			PortWriteChar(&Buffer, &BufferLength, x);
			PortWriteChar(&Buffer, &BufferLength, (y=((BaseList+z)->Y)));
			PortWriteString(&Buffer, &BufferLength, (BaseList+z)->Name);
			PortWriteString(&Buffer, &BufferLength, "\t");
			if ((Base = GetBaseChunk(x,y))!=NULL) {
				PortWriteChar(&Buffer, &BufferLength, Base->IsManufacturing);
				PortWriteChar(&Buffer, &BufferLength, Base->Level);			
			};
		}
		PortWriteString(&Buffer, &BufferLength, "\n");
		PortWriteBufferFlush(Buffer, Socket);
		PortWriteBufferClear(Buffer);
		
		// Units  --listing only
		UnitList = Player->Unit;
		HashPrepare(&Hash,&HashCounter, (Player->UnitCounter+1), 0x1ffff, 0x2ffff);
		for(y=0;y<(Player->UnitCounter);y++) {
			unsigned short int Moves;
			float MovesPerTurn;
			float MovesLeft;
			float Turns;
			z= (((UnitList+y)->X)<<8) + ((UnitList+y)->Y);
			if (!HashEntry(&Hash, &HashCounter, 0x1ffff, 0x2ffff, z)) {
				if ((Unit = GetUnitChunk( ((UnitList+y)->X), ((UnitList+y)->Y) ))!=NULL) {
					if (y>0) PortWriteString(&Buffer, &BufferLength, "\t");
					PortWriteChar(&Buffer, &BufferLength, (UnitList+y)->X);
					PortWriteChar(&Buffer, &BufferLength, (UnitList+y)->Y);
					if (Unit->ChunkType==5) {
						if (Unit->Units[0].UnitID!=0) {
							PortWriteSInt(&Buffer, &BufferLength, Unit->Units[0].UnitID);
							PortWriteChar(&Buffer, &BufferLength, Unit->Units[0].Type);
							if (( ((long) GW_CurrentTurn) - ((long)(Unit->Units[0].Turns)) )<0) {
								MovesPerTurn = ( ((float)( (GetUnitData(Unit->Units[0].Type)) ->Movement)) /10);
								Turns = (float) ((long) GW_CurrentTurn+65000) - ((long)(Unit->Units[0].Turns));
								MovesLeft = (((float) ((int) (Unit->Units[0].Moves)))/10);
								Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
							} else {
								MovesPerTurn = ( ((float)( (GetUnitData(Unit->Units[0].Type)) ->Movement)) /10);
								Turns = (float) ((long) GW_CurrentTurn) - ((long)(Unit->Units[0].Turns));
								MovesLeft = (((float) ((int) (Unit->Units[0].Moves)))/10);
								Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
							};
//							sprintf(FileName,"%f|%f|%f|%d|",MovesPerTurn,Turns,MovesLeft,Moves);print(FileName);
							PortWriteSInt(&Buffer, &BufferLength, Moves);
							PortWriteSInt(&Buffer, &BufferLength, Unit->Units[0].Life);
						};
					} else
						if (Unit->ChunkType==6) {
							for(z=0;z<4;z++)
								if (((struct Unit4 *) Unit)->Units[z].UnitID!=0) {
									PortWriteSInt(&Buffer, &BufferLength, ((struct Unit4 *) Unit)->Units[z].UnitID);
									PortWriteChar(&Buffer, &BufferLength, ((struct Unit4 *) Unit)->Units[z].Type);
									if (( ((long) GW_CurrentTurn) - ((long)(((struct Unit4 *) Unit)->Units[z].Turns)) )<0) {
										MovesPerTurn = ( ((float)( (GetUnitData(((struct Unit4 *) Unit)->Units[z].Type)) ->Movement)) /10);
										Turns = (float) ((long) GW_CurrentTurn+65000) - ((long)(((struct Unit4 *) Unit)->Units[z].Turns));
										MovesLeft = (((float) ((int) (((struct Unit4 *) Unit)->Units[z].Moves)))/10);
										Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
									} else {
										MovesPerTurn = ( ((float)( (GetUnitData(((struct Unit4 *) Unit)->Units[z].Type)) ->Movement)) /10);
										Turns = (float) (char) ((long) GW_CurrentTurn) - ((long)(((struct Unit4 *) Unit)->Units[z].Turns));
										MovesLeft = (((float) ((int) (((struct Unit4 *) Unit)->Units[z].Moves)))/10);
										Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
									};
//									sprintf(FileName,"%f|%f|%f|%d|",MovesPerTurn,Turns,MovesLeft,Moves);print(FileName);
									PortWriteSInt(&Buffer, &BufferLength, Moves);
									PortWriteSInt(&Buffer, &BufferLength, ((struct Unit4 *) Unit)->Units[z].Life);
								};					
						} else {
							for(z=0;z<8;z++)
								if (((struct Unit8 *) Unit)->Units[z].UnitID!=0) {
									PortWriteSInt(&Buffer, &BufferLength, ((struct Unit8 *) Unit)->Units[z].UnitID);
									PortWriteChar(&Buffer, &BufferLength, ((struct Unit8 *) Unit)->Units[z].Type);
									if (( ((long) GW_CurrentTurn) - ((long)(((struct Unit8 *) Unit)->Units[z].Turns)) )<0) {
										MovesPerTurn = ( ((float)( (GetUnitData(((struct Unit8 *) Unit)->Units[z].Type)) ->Movement)) /10);
										Turns = (float) ((long) GW_CurrentTurn+65000) - ((long)(((struct Unit8 *) Unit)->Units[z].Turns));
										MovesLeft = (((float) ((int) (((struct Unit8 *) Unit)->Units[z].Moves)))/10);
										Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
									} else {
										MovesPerTurn = ( ((float)( (GetUnitData(((struct Unit8 *) Unit)->Units[z].Type)) ->Movement)) /10);
										Turns = (float) ((long) GW_CurrentTurn) - ((long)(((struct Unit8 *) Unit)->Units[z].Turns));
										MovesLeft = (((float) ((int) (((struct Unit8 *) Unit)->Units[z].Moves)))/10);
										Moves = (unsigned short int) ((int) ((( Turns * MovesPerTurn) + MovesLeft)*10));
									};
//									sprintf(FileName,"%f|%f|%f|%d|",MovesPerTurn,Turns,MovesLeft,Moves);print(FileName);
									PortWriteSInt(&Buffer, &BufferLength, Moves);
									PortWriteSInt(&Buffer, &BufferLength, ((struct Unit8 *) Unit)->Units[z].Life);
								};
						};
				};
			};
		};
		free(Hash);
		PortWriteString(&Buffer, &BufferLength, "\n");
		PortWriteBufferFlush(Buffer, Socket);
		PortWriteBufferClear(Buffer);
		
		// Traps  --listing only
		UnitList = Player->Trap;
		for(z=0;z<(Player->TrapCounter);z++) {
			PortWriteChar(&Buffer, &BufferLength, (x=((UnitList+z)->X)));
			PortWriteChar(&Buffer, &BufferLength, (y=((UnitList+z)->Y)));
			if ((Trap = GetTrapChunk(x,y))!=NULL) {
				PortWriteChar(&Buffer, &BufferLength, Trap->Type);
			};
		}
		PortWriteString(&Buffer, &BufferLength, "\n");
		PortWriteBufferFlush(Buffer, Socket);
		PortWriteBufferClear(Buffer);
		
		// Barriers
		UnitList = Player->Barrier;
		for(z=0;z<(Player->BarrierCounter);z++) {
			PortWriteChar(&Buffer, &BufferLength, (x=((UnitList+z)->X)));
			PortWriteChar(&Buffer, &BufferLength, (y=((UnitList+z)->Y)));
			if ((Barrier = GetBarrierChunk(x,y))!=NULL) {
				PortWriteChar(&Buffer, &BufferLength, Barrier->Type);
			};
		}
		PortWriteString(&Buffer, &BufferLength, "\n");
		PortWriteBufferFlush(Buffer, Socket);
		PortWriteBufferClear(Buffer);
		
		// Settlements  --listing w/ names
		BaseList = Player->Settlement;
		for(z=0;z<(Player->SettlementCounter);z++) {
			PortWriteChar(&Buffer, &BufferLength, (x=((BaseList+z)->X)));
			PortWriteChar(&Buffer, &BufferLength, (y=((BaseList+z)->Y)));
			PortWriteString(&Buffer, &BufferLength, (BaseList+z)->Name);
			PortWriteString(&Buffer, &BufferLength, "\t");
			if ((Settlement = GetSettlementChunk(x,y))!=NULL) {
				PortWriteChar(&Buffer, &BufferLength, Settlement->Level);
				PortWriteChar(&Buffer, &BufferLength, Settlement->FundingFocus);
			};
		}
		PortWriteString(&Buffer, &BufferLength, "\n");
		PortWriteBufferFlush(Buffer, Socket);
		PortWriteBufferClear(Buffer);
		
		// Offline Events
		if ((LogFile = fopen(FileName,"r"))!=NULL) {
			// UnImplemented.... Unknown format.			
			fclose(LogFile);
		};
		
		PortWriteString(&Buffer, &BufferLength, "\n");
		PortWriteBufferFlush(Buffer, Socket);
		PortWriteBufferClear(Buffer);
		
		// Current Field View
			if((x=Player->Base->X)<2) x=0; else x = x-2;
			if((y=Player->Base->Y)<2) y=0; else y = y-2;
			SendCompleteData(&Buffer, &BufferLength, Socket, x, y, Player);			
				
	// Phase everything...
	
	ActiveLogOff(PlayerCode);
	fclose(Socket);
	free(Buffer);
	return;
};
